#include <iostream.h>
#include <stdlib.h>
#include <string.h>
#include "BigInteger.h"
#include "parse.h"

bool isNumericDigit(char c)  {
	
	if (c >= 48 && c <= 57)
		return true;
	return false;
}

char* arrayCopy(char* src, int start, int end)  {
	
	int temp_length;
	int i;
	char* temp;

	temp_length = end - start + 1;
	temp = new char[temp_length + 1];

	for (i = 0; i < temp_length; i++)  {
		temp[i] = src[i + start];
	}
	temp[temp_length] = '\0';

	return temp;
}

BigInteger parseInput(char *input)   {
	
	char* temp;
	BigInteger result = 0;
	BigInteger value;
	int input_length;
	int start_offset, end_offset;
	int counter;
	bool add = true;

	// If the first character is not a numeric digit
	if (isNumericDigit(input[0]) == false)  {
		return NULL;
	}

	input_length = strlen(input);

	start_offset = 0;
	counter = 1;

	while (counter < input_length)  {
		if (input[counter] == '+' || input[counter] == '-')  {
			end_offset = counter - 1;
			temp = arrayCopy(input, start_offset, end_offset);
			value = parseNumber(temp);
			delete [] temp;
			if (value == NULL)  
				return NULL;
			else  {
				if (add == true) 
					result += value;
				else result -= value;
			}
			if (input[counter] == '+')
				add = true;
			else add = false;
			start_offset = counter + 1;
			counter = start_offset + 1;
		}
		else counter++;
	}

	end_offset = input_length - 1;
	temp = arrayCopy(input, start_offset, end_offset);
	value = parseNumber(temp);
	delete [] temp;
	if (value == NULL)  
		return NULL;
	else  {
		if (add == true) 
			result += value;
		else result -= value;
	}
	return result;
}

BigInteger parseNumber(char *num)  {

	int i, num_length;
	int powerCharPos = -1;
	char *tokenptr;
	
	// If the first character is not a numeric digit
	if (isNumericDigit(num[0]) == false)  {
		return NULL;
	}

	num_length = strlen(num);

	// If the last character is not a numer digit
	if (isNumericDigit(num[num_length - 1]) == false)  {
		return NULL;
	}

	// Check whether contains _ character or not
	for (i = 1; i < num_length; i++)  {
		if (num[i] == '_' && powerCharPos == -1)  {
			powerCharPos = i;
		}
		else  {
			if (isNumericDigit(num[i]) == false)   {
				return NULL;
			}
		}
	}

	if (powerCharPos == -1)  {
		BigInteger value(num);
		return value;
	}
	else  {
		tokenptr = strtok(num, "_");
		BigInteger base(tokenptr);
		tokenptr = strtok(NULL, " ");
		BigInteger exp(tokenptr);
		BigInteger value = Power(base, exp.ToLong(exp));
		return value;
	}

	return NULL;
}

