#ifndef SPECTRAL_H
#define SPECTRAL_H
#include "BigInteger.h"
#include "matrix.h"

class Spectral  {
	
	public:
		Spectral(BigInteger m, BigInteger a);
		BigInteger m;
		BigInteger a;
		void Initialize();
		void EuclideanStep();
		BigInteger ComputeVt_square(int t);
		void SetUpUAndV();
		void Advance_t();
		void Transform();
		void Searching();
		void SpectralTest(int T);

	private:
		long t;
		long j;
		long k;
		BigInteger h;
		BigInteger h_dash;
		BigInteger p;
		BigInteger p_dash;
		BigInteger r;
		BigInteger s;
		BigInteger u;
		BigInteger v;
		BigInteger q;
		Matrix U;
		Matrix V;
		BigInteger minimum(BigInteger a, BigInteger b);
		unsigned long GCD(unsigned long, unsigned long);
		BigInteger GCD(BigInteger a, BigInteger b);
};

#endif